library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity decoder2x4 is
port ( i: in bit_vector(0 to 1);
       en: in bit;
       q: out bit_vector( 0 to 3)
       );
 end decoder2x4;
 
 architecture dataflow of decoder2x4 is
 signal t: bit_vector(0 to 3);
 begin
    
     t <=  "1000" when i="00" else
           "0100" when i="01" else
           "0010" when i="10" else
           "0001" ;
      
     q <= t after 2 ns when en= '1' else
          "0000";              
 end dataflow;
