library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity decoder2x4 is
port ( i: in bit_vector(0 to 1);
       en: in bit;
       q: out bit_vector( 0 to 3)
       );
 end decoder2x4;
 
 architecture dataflow of decoder2x4 is
  begin
    
     q <=  "1000" after 2 ns when i="00" and en = '1' else
           "0100" after 2 ns when i="01" and en = '1' else
           "0010" after 2 ns when i="10" and en = '1' else
           "0001" after 2 ns when i="10" and en = '1' else
	    "0000" after 2 ns;
      
               
 end dataflow;
